CREATE TABLE XX_T_ACK_PENDING_EVENT
(
  ID                         NUMERIC(19) NOT NULL PRIMARY KEY,
  ACKNOWLEDGEMENT_PART_INDEX VARCHAR(255),
  CHANNEL                    VARCHAR(255),
  EMITTER                    VARCHAR(255),
  EVENT_BODY                 TEXT,
  EVENT_ID                   VARCHAR(255),
  EVENT_TYPE                 VARCHAR(255),
  PROTOCOL_ID                VARCHAR(255),
  ROUTING_KEY                VARCHAR(255)
);

CREATE UNIQUE INDEX UNIQUE_PENDING_EVENTS
  ON XX_T_ACK_PENDING_EVENT (EVENT_ID, ACKNOWLEDGEMENT_PART_INDEX);

CREATE SEQUENCE xx_unacked_event_id_sequence
  CACHE 25;

CREATE TABLE XX_T_EVENTLOG
(
  ID            NUMERIC(19) NOT NULL,
  JSON_PAYLOAD  TEXT,
  KEY           NUMERIC(10),
  PROTOCOL_ID   VARCHAR(255),
  SECONDARY_KEY NUMERIC(10),
  TYPE          VARCHAR(255)
)
  PARTITION BY LIST (TYPE);

CREATE TABLE XX_T_EVENTLOG_VOTERS
PARTITION OF XX_T_EVENTLOG
FOR VALUES IN ('VOTER_ADDED');

CREATE UNIQUE INDEX UNIQUE_KEY_VOTERS
  ON XX_T_EVENTLOG_VOTERS (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_VOTERS
  ON XX_T_EVENTLOG_VOTERS (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_VOTERS
  ON XX_T_EVENTLOG_VOTERS (PROTOCOL_ID, TYPE);

CREATE TABLE XX_T_EVENTLOG_VOTER_DATA
PARTITION OF XX_T_EVENTLOG
FOR VALUES IN ('VOTER_DATA_ADDED');

CREATE UNIQUE INDEX UNIQUE_KEY_VOTER_DATA
  ON XX_T_EVENTLOG_VOTER_DATA (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_VOTER_DATA
  ON XX_T_EVENTLOG_VOTER_DATA (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_VOTER_DATA
  ON XX_T_EVENTLOG_VOTER_DATA (PROTOCOL_ID, TYPE);


CREATE TABLE XX_T_EVENTLOG_CREDS PARTITION OF XX_T_EVENTLOG
FOR VALUES IN ('PUBLIC_CREDENTIALS_ADDED');
CREATE UNIQUE INDEX UNIQUE_KEY_CREDS
  ON XX_T_EVENTLOG_CREDS (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_CREDS
  ON XX_T_EVENTLOG_CREDS (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_CREDS
  ON XX_T_EVENTLOG_CREDS (PROTOCOL_ID, TYPE);

CREATE TABLE XX_T_EVENTLOG_CREDS_PARTS PARTITION OF XX_T_EVENTLOG
FOR VALUES IN ('PUBLIC_CREDENTIALS_PART_ADDED');
CREATE UNIQUE INDEX UNIQUE_KEY_CREDS_PARTS
  ON XX_T_EVENTLOG_CREDS_PARTS (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_CREDS_PARTS
  ON XX_T_EVENTLOG_CREDS_PARTS (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_CREDS_PARTS
  ON XX_T_EVENTLOG_CREDS_PARTS (PROTOCOL_ID, TYPE);

CREATE TABLE XX_T_EVENTLOG_BALLOTS PARTITION OF XX_T_EVENTLOG
FOR VALUES IN ('BALLOT_ENTRY_ADDED', 'BALLOT_AND_QUERY_ADDED');
CREATE UNIQUE INDEX UNIQUE_KEY_BALLOTS
  ON XX_T_EVENTLOG_BALLOTS (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_BALLOTS
  ON XX_T_EVENTLOG_BALLOTS (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_BALLOTS
  ON XX_T_EVENTLOG_BALLOTS (PROTOCOL_ID, TYPE);

CREATE TABLE XX_T_EVENTLOG_CONFS PARTITION OF XX_T_EVENTLOG
FOR VALUES IN ('CONFIRMATION_ENTRY_ADDED', 'CONFIRMATION_ADDED');
CREATE UNIQUE INDEX UNIQUE_KEY_CONFS
  ON XX_T_EVENTLOG_CONFS (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_CONFS
  ON XX_T_EVENTLOG_CONFS (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_CONFS
  ON XX_T_EVENTLOG_CONFS (PROTOCOL_ID, TYPE);

CREATE TABLE XX_T_EVENTLOG_OTHERS PARTITION OF XX_T_EVENTLOG
FOR VALUES IN (
  'CC_PUBLIC_KEY_ADDED',
  'ELECTION_OFFICER_PUBLIC_KEY_ADDED',
  'ELECTION_SET_ADDED',
  'ENCRYPTION_KEY_PAIR_ADDED',
  'GENERATORS_ADDED',
  'PRIMES_ADDED',
  'PUBLIC_PARAMETERS_ADDED',
  'SHUFFLES_ADDED',
  'SHUFFLE_PROOFS_ADDED',
  'SHUFFLE_AND_PROOF_ADDED',
  'SHUFFLE_VERIFICATION_ADDED',
  'SYSTEM_PUBLIC_KEY_ADDED',
  'DECRYPTIONS_ADDED',
  'DECRYPTION_PROOFS_ADDED',
  'TALLY_ADDED'
);
CREATE UNIQUE INDEX UNIQUE_KEY_OTHERS
  ON XX_T_EVENTLOG_OTHERS (PROTOCOL_ID, TYPE, KEY, SECONDARY_KEY);
CREATE INDEX IDX_TYPE_KEY_OTHERS
  ON XX_T_EVENTLOG_OTHERS (PROTOCOL_ID, TYPE, KEY);
CREATE INDEX IDX_TYPE_OTHERS
  ON XX_T_EVENTLOG_OTHERS (PROTOCOL_ID, TYPE);

CREATE SEQUENCE xx_event_id_sequence
  CACHE 25;